$(() => {
$.connection.hub.url = 'https://js.devexpress.com/Demos/Mvc/signalr';
const hub = $.connection.stockTickDataHub;
const store = new DevExpress.data.CustomStore({
load() {
return hub.server.getAllData();
},
key: 'Date',
});
hub.client.updateStockPrice = function (data) {
store.push([{ type: 'insert', key: data.Date, data }]);
};
$.connection.hub.start({ waitForPageLoad: false }).done(() => {
$('#chart').dxChart({
dataSource: store,
margin: {
right: 30,
},
loadingIndicator: {
enabled: true,
},
title: 'Stock Price',
series: [{
pane: 'Price',
argumentField: 'Date',
type: 'candlestick',
aggregation: {
enabled: true,
method: 'custom',
calculate(e) {
const prices = e.data.map((i) => i.Price);
if (prices.length) {
return {
Date: new Date((e.intervalStart.valueOf() + e.intervalEnd.valueOf()) / 2),
open: prices[0],
high: Math.max.apply(null, prices),
low: Math.min.apply(null, prices),
close: prices[prices.length - 1],
};
}
return null;
},
},
}, {
pane: 'Volume',
name: 'Volume',
argumentField: 'Date',
type: 'bar',
valueField: 'Volume',
color: 'red',
aggregation: {
enabled: true,
method: 'sum',
},
}],
panes: [{
name: 'Price',
}, {
name: 'Volume',
height: 80,
}],
customizePoint(arg) {
if (arg.seriesName === 'Volume') {
const point = $('#chart').dxChart('getAllSeries')[0].getPointsByArg(arg.argument)[0].data;
if (point.close >= point.open) {
return { color: '#1db2f5' };
}
}
return null;
},
tooltip: {
enabled: true,
shared: true,
argumentFormat: 'shortDateShortTime',
contentTemplate(pointInfo, element) {
const print = function (label, value) {
const span = $('<span>', {
class: 'tooltip-label',
text: label,
});
element.append($('<div>', {
text: value,
}).prepend(span));
};
const volume = pointInfo.points.filter((point) => point.seriesName === 'Volume')[0];
const prices = pointInfo.points.filter((point) => point.seriesName !== 'Volume')[0];
print('', pointInfo.argumentText);
print('Open: ', formatCurrency(prices.openValue));
print('High: ', formatCurrency(prices.highValue));
print('Low: ', formatCurrency(prices.lowValue));
print('Close: ', formatCurrency(prices.closeValue));
print('Volume: ', formatNumber(volume.value));
},
},
crosshair: {
enabled: true,
horizontalLine: { visible: false },
},
zoomAndPan: {
argumentAxis: 'both',
},
scrollBar: {
visible: true,
},
legend: {
visible: false,
},
argumentAxis: {
argumentType: 'datetime',
minVisualRangeLength: { minutes: 10 },
visualRange: {
length: 'hour',
},
},
valueAxis: {
placeholderSize: 50,
},
});
});
const formatCurrency = new Intl.NumberFormat('en-US', { style: 'currency', currency: 'USD', minimumFractionDigits: 2 }).format;
const formatNumber = new Intl.NumberFormat('en-US', { maximumFractionDigits: 0 }).format;
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<script src="https://unpkg.com/signalr@2.4.3/jquery.signalR.js"></script>
<script src="../signalr-hub.js"></script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/23.1.6/css/dx.light.css" />
<script src="https://cdn3.devexpress.com/jslib/23.1.6/js/dx.all.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="chart"></div>
</div>
</body>
</html>
#chart {
height: 440px;
}
.tooltip-label {
font-weight: 500;
}
using System.Collections.Generic;
using DevExtreme.MVC.Demos.Models.SignalRTickData;
using Microsoft.AspNet.SignalR;
namespace DevExtreme.MVC.Demos.Hubs {
public class StockTickDataHub : Hub {
private readonly TickDataService _service;
public StockTickDataHub() {
_service = TickDataService.Instance;
}
public IEnumerable<TickItem> GetAllData() {
return _service.GetAllData();
}
}
}
using DevExtreme.MVC.Demos.Hubs;
using Microsoft.AspNet.SignalR;
using Microsoft.AspNet.SignalR.Hubs;
using System;
using System.Collections.Generic;
using System.Threading;
namespace DevExtreme.MVC.Demos.Models.SignalRTickData {
public class TickDataService {
public readonly static TickDataService Instance = new TickDataService(GlobalHost.ConnectionManager.GetHubContext<StockTickDataHub>().Clients);
private IHubConnectionContext<dynamic> Clients { get; set; }
private readonly object updateStockPricesLock = new object();
private TickItem[] tickData;
private int lastTickIndex;
private Timer timer;
private TickDataService(IHubConnectionContext<dynamic> clients) {
Clients = clients;
tickData = GenerateTestData();
lastTickIndex = tickData.Length - 1;
timer = new Timer(Update, null, 1000, 1000);
}
public IEnumerable<TickItem> GetAllData() {
var data = new List<TickItem>();
lock(updateStockPricesLock) {
for(var i = lastTickIndex; data.Count < 10000; i--) {
data.Add(tickData[i]);
if(i == 0) {
i = tickData.Length - 1;
}
}
}
return data;
}
private void Update(object state) {
lock(updateStockPricesLock) {
lastTickIndex = (lastTickIndex + 1) % tickData.Length;
var tick = tickData[lastTickIndex];
tick.Date = DateTime.Now;
BroadcastStockPrice(tick);
}
}
private void BroadcastStockPrice(TickItem item) {
Clients.All.updateStockPrice(item);
}
private TickItem[] GenerateTestData() {
var lastPrice = 140m;
var random = new Random();
var slowRandomValue = random.NextDouble();
var data = new TickItem[60 * 60 * 20];
var curTime = DateTime.Now;
for(var i = 0; i < data.Length / 2; i++) {
lastPrice = Math.Round(lastPrice * (decimal)(1 + 0.002 * (-1 + 2 * random.NextDouble())), 2);
if(i % 50 == 0) {
slowRandomValue = random.NextDouble();
if(slowRandomValue > 0.3 && slowRandomValue <= 0.5) slowRandomValue -= 0.2;
if(slowRandomValue > 0.5 && slowRandomValue <= 0.7) slowRandomValue += 0.2;
}
var volume = (int)(100 + 1900 * random.NextDouble() * slowRandomValue);
data[data.Length - 1 - i] = new TickItem(lastPrice, volume, curTime.AddSeconds(-1 * i));
data[i] = new TickItem(lastPrice, volume, curTime.AddSeconds(-1 * (data.Length - 1 - i)));
}
return data;
}
}
}

<div ng-if="connectionStarted">
<dx-chart
id="chart"
[dataSource]="dataSource"
title="Stock Price"
[customizePoint]="customizePoint"
>
<dxi-series pane="Price" argumentField="date" type="candlestick">
<dxo-aggregation
[enabled]="true"
method="custom"
[calculate]="calculateCandle"
>
</dxo-aggregation>
</dxi-series>
<dxi-series
pane="Volume"
name="Volume"
argumentField="date"
valueField="volume"
color="red"
type="bar"
>
<dxo-aggregation [enabled]="true" method="sum"> </dxo-aggregation>
</dxi-series>
<dxi-pane name="Price"></dxi-pane>
<dxi-pane name="Volume" [height]="80"></dxi-pane>
<dxo-tooltip
[enabled]="true"
[shared]="true"
argumentFormat="shortDateShortTime"
contentTemplate="tooltipTemplate"
></dxo-tooltip>
<dxo-crosshair
[enabled]="true"
[horizontalLine]="{ visible: false }"
></dxo-crosshair>
<dxo-margin [right]="30"></dxo-margin>
<dxo-scroll-bar [visible]="true"></dxo-scroll-bar>
<dxo-legend [visible]="false"></dxo-legend>
<dxi-value-axis [placeholderSize]="50"></dxi-value-axis>
<dxo-zoom-and-pan argumentAxis="both"></dxo-zoom-and-pan>
<dxo-argument-axis
argumentType="datetime"
[minVisualRangeLength]="{ minutes: 10 }"
[visualRange]="{ length: 'hour' }"
></dxo-argument-axis>
<dxo-loading-indicator [enabled]="true"></dxo-loading-indicator>
<div *dxTemplate="let pointInfo of 'tooltipTemplate'">
<div class="tooltip-template">
<div>{{ pointInfo.argumentText }}</div>
<div>
<span>Open: </span>
{{ formatPrice(pointInfo.points, "openValue") }}
</div>
<div>
<span>High: </span>
{{ formatPrice(pointInfo.points, "highValue") }}
</div>
<div>
<span>Low: </span>
{{ formatPrice(pointInfo.points, "lowValue") }}
</div>
<div>
<span>Close: </span>
{{ formatPrice(pointInfo.points, "closeValue") }}
</div>
<div>
<span>Volume: </span>
{{ formatVolume(pointInfo.points) }}
</div>
</div>
</div>
</dx-chart>
</div>
import {
NgModule, Component, ViewChild, enableProdMode,
} from '@angular/core';
import { DecimalPipe, CurrencyPipe } from '@angular/common';
import { BrowserModule, BrowserTransferStateModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { HubConnectionBuilder, HttpTransportType } from '@aspnet/signalr';
import { DxChartModule, DxChartComponent } from 'devextreme-angular';
import CustomStore from 'devextreme/data/custom_store';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
@Component({
selector: 'demo-app',
templateUrl: 'app/app.component.html',
styleUrls: ['app/app.component.css'],
providers: [DecimalPipe, CurrencyPipe],
})
export class AppComponent {
@ViewChild(DxChartComponent, { static: false }) component: DxChartComponent;
dataSource: any;
connectionStarted: boolean;
constructor(private decimalPipe: DecimalPipe, private currencyPipe: CurrencyPipe) {
this.connectionStarted = false;
const hubConnection = new HubConnectionBuilder()
.withUrl('https://js.devexpress.com/Demos/NetCore/stockTickDataHub', {
skipNegotiation: true,
transport: HttpTransportType.WebSockets,
})
.build();
const store = new CustomStore({
load: () => hubConnection.invoke('getAllData'),
key: 'date',
});
hubConnection
.start()
.then(() => {
hubConnection.on('updateStockPrice', (data: any) => {
store.push([{ type: 'insert', key: data.date, data }]);
});
this.dataSource = store;
this.connectionStarted = true;
});
}
calculateCandle(e) {
const prices = e.data.map((d) => d.price);
if (prices.length) {
return {
date: new Date((e.intervalStart.valueOf() + e.intervalEnd.valueOf()) / 2),
open: prices[0],
high: Math.max.apply(null, prices),
low: Math.min.apply(null, prices),
close: prices[prices.length - 1],
};
}
}
customizePoint = (arg: any) => {
if (arg.seriesName === 'Volume') {
const point = this.component.instance.getAllSeries()[0].getPointsByArg(arg.argument)[0].data;
if (point.close >= point.open) {
return { color: '#1db2f5' };
}
}
};
formatPrice = (points: any, field: any) => {
const pricePoint = points.filter((point) => point.seriesName !== 'Volume')[0];
return this.currencyPipe.transform(pricePoint[field], 'USD', 'symbol', '1.0-0');
};
formatVolume = (points: any) => {
const volPoint = points.filter((point) => point.seriesName === 'Volume')[0];
return this.decimalPipe.transform(volPoint.value, '3.0-0');
};
}
@NgModule({
imports: [
BrowserModule,
BrowserTransferStateModule,
DxChartModule,
],
declarations: [AppComponent],
bootstrap: [AppComponent],
})
export class AppModule { }
platformBrowserDynamic().bootstrapModule(AppModule);
::ng-deep #chart {
height: 440px;
}
::ng-deep .tooltip-template span {
font-weight: 500;
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
map: {
'ts': 'npm:plugin-typescript@4.2.4/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'@angular/core': 'npm:@angular/core@12.2.17',
'@angular/platform-browser': 'npm:@angular/platform-browser@12.2.17',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic@12.2.17',
'@angular/forms': 'npm:@angular/forms@12.2.17',
'@angular/common': 'npm:@angular/common@12.2.17',
'@angular/compiler': 'npm:@angular/compiler@12.2.17',
'tslib': 'npm:tslib@2.3.1/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'@aspnet/signalr': 'npm:@aspnet/signalr@1.0.27/dist/cjs/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.1/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@23.1.6/cjs',
'devextreme/bundles/dx.all': 'npm:devextreme@23.1.6/bundles/dx.all.js',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.6.2/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.2',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.49',
'devextreme-angular': 'npm:devextreme-angular@23.1.6',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.12',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.4/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.4/parser-html.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.12/inferno/package.json',
'npm:@angular/*/package.json',
'npm:@angular/common@12.2.17/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devextreme-angular@23.1.6/*/package.json',
'npm:devextreme-angular@23.1.6/ui/*/package.json',
'npm:devextreme-angular@23.1.6/package.json',
'npm:devexpress-diagram@2.2.2/package.json',
'npm:devexpress-gantt@4.1.49/package.json',
'npm:@aspnet/*/package.json',
],
};
System.config(window.config);
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/23.1.5/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://unpkg.com/zone.js@0.12.0/dist/zone.js"></script>
<script src="https://unpkg.com/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>
using System.Collections.Generic;
using DevExtreme.MVC.Demos.Models.SignalRTickData;
using Microsoft.AspNet.SignalR;
namespace DevExtreme.MVC.Demos.Hubs {
public class StockTickDataHub : Hub {
private readonly TickDataService _service;
public StockTickDataHub() {
_service = TickDataService.Instance;
}
public IEnumerable<TickItem> GetAllData() {
return _service.GetAllData();
}
}
}
using DevExtreme.MVC.Demos.Hubs;
using Microsoft.AspNet.SignalR;
using Microsoft.AspNet.SignalR.Hubs;
using System;
using System.Collections.Generic;
using System.Threading;
namespace DevExtreme.MVC.Demos.Models.SignalRTickData {
public class TickDataService {
public readonly static TickDataService Instance = new TickDataService(GlobalHost.ConnectionManager.GetHubContext<StockTickDataHub>().Clients);
private IHubConnectionContext<dynamic> Clients { get; set; }
private readonly object updateStockPricesLock = new object();
private TickItem[] tickData;
private int lastTickIndex;
private Timer timer;
private TickDataService(IHubConnectionContext<dynamic> clients) {
Clients = clients;
tickData = GenerateTestData();
lastTickIndex = tickData.Length - 1;
timer = new Timer(Update, null, 1000, 1000);
}
public IEnumerable<TickItem> GetAllData() {
var data = new List<TickItem>();
lock(updateStockPricesLock) {
for(var i = lastTickIndex; data.Count < 10000; i--) {
data.Add(tickData[i]);
if(i == 0) {
i = tickData.Length - 1;
}
}
}
return data;
}
private void Update(object state) {
lock(updateStockPricesLock) {
lastTickIndex = (lastTickIndex + 1) % tickData.Length;
var tick = tickData[lastTickIndex];
tick.Date = DateTime.Now;
BroadcastStockPrice(tick);
}
}
private void BroadcastStockPrice(TickItem item) {
Clients.All.updateStockPrice(item);
}
private TickItem[] GenerateTestData() {
var lastPrice = 140m;
var random = new Random();
var slowRandomValue = random.NextDouble();
var data = new TickItem[60 * 60 * 20];
var curTime = DateTime.Now;
for(var i = 0; i < data.Length / 2; i++) {
lastPrice = Math.Round(lastPrice * (decimal)(1 + 0.002 * (-1 + 2 * random.NextDouble())), 2);
if(i % 50 == 0) {
slowRandomValue = random.NextDouble();
if(slowRandomValue > 0.3 && slowRandomValue <= 0.5) slowRandomValue -= 0.2;
if(slowRandomValue > 0.5 && slowRandomValue <= 0.7) slowRandomValue += 0.2;
}
var volume = (int)(100 + 1900 * random.NextDouble() * slowRandomValue);
data[data.Length - 1 - i] = new TickItem(lastPrice, volume, curTime.AddSeconds(-1 * i));
data[i] = new TickItem(lastPrice, volume, curTime.AddSeconds(-1 * (data.Length - 1 - i)));
}
return data;
}
}
}

Backend API
<template>
<div v-if="connectionStarted">
<DxChart
id="chart"
ref="chartRef"
:data-source="dataSource"
:margin="{right: 30}"
:customize-point="customizePoint"
zooming-mode="all"
scrolling-mode="all"
title="Stock Price"
>
<DxSeries
argument-field="date"
type="candlestick"
pane="Price"
>
<DxAggregation
:enabled="true"
:calculate="calculateCandle"
method="custom"
/>
</DxSeries>
<DxSeries
argument-field="date"
value-field="volume"
type="bar"
color="red"
pane="Volume"
name="Volume"
>
<DxAggregation
:enabled="true"
method="sum"
/>
</DxSeries>
<DxPane name="Price"/>
<DxPane
:height="80"
name="Volume"
/>
<DxLegend :visible="false"/>
<DxArgumentAxis
:min-visual-range-length="{minutes: 10}"
:visual-range="{length: 'hour'}"
argument-type="datetime"
/>
<DxZoomAndPan argument-axis="both"/>
<DxValueAxis :placeholder-size="50"/>
<DxScrollBar :visible="true"/>
<DxLoadingIndicator :enabled="true"/>
<DxTooltip
:enabled="true"
:shared="true"
argument-format="shortDateShortTime"
content-template="tooltipTemplate"
/>
<DxCrosshair
:enabled="true"
:horizontal-line="{visible: false}"
/>
<template #tooltipTemplate="{ data }">
<TooltipTemplate :point-info="data"/>
</template>
</DxChart>
</div>
</template>
<script setup lang="ts">
import { ref } from 'vue';
import {
DxChart,
DxArgumentAxis,
DxValueAxis,
DxAggregation,
DxSeries,
DxLegend,
DxScrollBar,
DxZoomAndPan,
DxLoadingIndicator,
DxPane,
DxTooltip,
DxCrosshair,
} from 'devextreme-vue/chart';
import type { chartPointAggregationInfoObject } from 'devextreme/viz/chart';
import { CustomStore } from 'devextreme-vue/common/data';
import { HubConnectionBuilder, HttpTransportType } from '@aspnet/signalr';
import TooltipTemplate from './TooltipTemplate.vue';
const chartRef = ref<DxChart>();
const connectionStarted = ref(false);
const dataSource = ref<CustomStore>();
const hubConnection = new HubConnectionBuilder()
.withUrl('https://js.devexpress.com/Demos/NetCore/stockTickDataHub', {
skipNegotiation: true,
transport: HttpTransportType.WebSockets,
})
.build();
const store = new CustomStore({
load: () => hubConnection.invoke('getAllData'),
key: 'date',
});
hubConnection
.start()
.then(() => {
hubConnection.on('updateStockPrice', (data) => {
store.push([{ type: 'insert', key: data.date, data }]);
});
dataSource.value = store;
connectionStarted.value = true;
});
function calculateCandle(e: chartPointAggregationInfoObject) {
const prices = (e.data || []).map((d) => d.price);
if (prices.length) {
return {
date: new Date((e.intervalStart.valueOf() + e.intervalEnd.valueOf()) / 2),
open: prices[0],
high: Math.max.apply(null, prices),
low: Math.min.apply(null, prices),
close: prices[prices.length - 1],
};
}
return [];
}
function customizePoint(pointInfo: Record<string, any>) {
if (pointInfo.seriesName === 'Volume') {
const point = chartRef.value?.instance
?.getAllSeries()[0]
.getPointsByArg(pointInfo.argument)[0]
.data;
if (point && point.close >= point.open) {
return { color: '#1db2f5' };
}
}
return { color: undefined };
}
</script>
<style>
#chart {
height: 440px;
}
</style>
<template>
<div class="tooltip-template">
<div>{{ pointInfo.argumentText }}</div>
<div><span>Open: </span>
{{ formatCurrency(prices.openValue) }}
</div>
<div><span>High: </span>
{{ formatCurrency(prices.highValue) }}
</div>
<div><span>Low: </span>
{{ formatCurrency(prices.lowValue) }}
</div>
<div><span>Close: </span>
{{ formatCurrency(prices.closeValue) }}
</div>
<div><span>Volume: </span>
{{ formatNumber(volume.value) }}
</div>
</div>
</template>
<script setup lang="ts">
import { computed } from 'vue';
const props = withDefaults(defineProps<{
pointInfo: Record<string, any>
}>(), {
pointInfo: () => ({} as Record<string, any>),
});
const volume = computed<{ value: number }>(() => props.pointInfo.points.filter(({ seriesName }: any) => seriesName === 'Volume')[0]);
const prices = computed<Record<string, any>>(() => props.pointInfo.points.filter(({ seriesName }: any) => seriesName !== 'Volume')[0]);
const formatCurrency = new Intl.NumberFormat('en-US',
{ style: 'currency', currency: 'USD', minimumFractionDigits: 0 }).format;
const formatNumber = new Intl.NumberFormat('en-US', {
minimumFractionDigits: 0,
}).format;
</script>
<style>
.tooltip-template span {
font-weight: 500;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.32/dist/vue.esm-browser.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'project:utils/demo-ts-loader.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'@aspnet/signalr': 'npm:@aspnet/signalr@1.0.27/dist/cjs',
'tslib': 'npm:tslib/tslib.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'@aspnet/signalr': {
main: 'index.js',
defaultExtension: 'js',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.8/css/dx.light.css" />
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/typescript@5.9.3/lib/typescript.js"></script>
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>
using System.Collections.Generic;
using DevExtreme.MVC.Demos.Models.SignalRTickData;
using Microsoft.AspNet.SignalR;
namespace DevExtreme.MVC.Demos.Hubs {
public class StockTickDataHub : Hub {
private readonly TickDataService _service;
public StockTickDataHub() {
_service = TickDataService.Instance;
}
public IEnumerable<TickItem> GetAllData() {
return _service.GetAllData();
}
}
}
using DevExtreme.MVC.Demos.Hubs;
using Microsoft.AspNet.SignalR;
using Microsoft.AspNet.SignalR.Hubs;
using System;
using System.Collections.Generic;
using System.Threading;
using DevExpress.Data.Utils;
namespace DevExtreme.MVC.Demos.Models.SignalRTickData {
public class TickDataService {
public readonly static TickDataService Instance = new TickDataService(GlobalHost.ConnectionManager.GetHubContext<StockTickDataHub>().Clients);
private IHubConnectionContext<dynamic> Clients { get; set; }
private readonly object updateStockPricesLock = new object();
private TickItem[] tickData;
private int lastTickIndex;
private Timer timer;
private TickDataService(IHubConnectionContext<dynamic> clients) {
Clients = clients;
tickData = GenerateTestData();
lastTickIndex = tickData.Length - 1;
timer = new Timer(Update, null, 1000, 1000);
}
public IEnumerable<TickItem> GetAllData() {
var data = new List<TickItem>();
lock(updateStockPricesLock) {
for(var i = lastTickIndex; data.Count < 10000; i--) {
data.Add(tickData[i]);
if(i == 0) {
i = tickData.Length - 1;
}
}
}
return data;
}
private void Update(object state) {
lock(updateStockPricesLock) {
lastTickIndex = (lastTickIndex + 1) % tickData.Length;
var tick = tickData[lastTickIndex];
tick.Date = DateTime.Now;
BroadcastStockPrice(tick);
}
}
private void BroadcastStockPrice(TickItem item) {
Clients.All.updateStockPrice(item);
}
private TickItem[] GenerateTestData() {
var lastPrice = 140m;
var random = NonCryptographicRandom.System;
var slowRandomValue = random.NextDouble();
var data = new TickItem[60 * 60 * 20];
var curTime = DateTime.Now;
for(var i = 0; i < data.Length / 2; i++) {
lastPrice = Math.Round(lastPrice * (decimal)(1 + 0.002 * (-1 + 2 * random.NextDouble())), 2);
if(i % 50 == 0) {
slowRandomValue = random.NextDouble();
if(slowRandomValue > 0.3 && slowRandomValue <= 0.5) slowRandomValue -= 0.2;
if(slowRandomValue > 0.5 && slowRandomValue <= 0.7) slowRandomValue += 0.2;
}
var volume = (int)(100 + 1900 * random.NextDouble() * slowRandomValue);
data[data.Length - 1 - i] = new TickItem(lastPrice, volume, curTime.AddSeconds(-1 * i));
data[i] = new TickItem(lastPrice, volume, curTime.AddSeconds(-1 * (data.Length - 1 - i)));
}
return data;
}
}
}
To display updated data in real time, use the aggregation configuration object. In this object, set the enabled property to true, the method property to custom, and then implement the calculate function to process the incoming data. In this demo, the calculate function aggregates data into a one point for each interval.
You can also use the contentTemplate function to update the tooltip content with incoming data.

Feel free to share demo-related thoughts here.
If you have technical questions, please create a support ticket in the DevExpress Support Center.
Thank you for the feedback!
If you have technical questions, please create a support ticket in the DevExpress Support Center.
Backend API
import React, {
useCallback, useEffect, useRef, useState,
} from 'react';
import Chart, {
ArgumentAxis,
ValueAxis,
Aggregation,
Legend,
Series,
ScrollBar,
ZoomAndPan,
LoadingIndicator,
Pane,
Tooltip,
Crosshair,
Margin,
HorizontalLine,
IAggregationProps,
} from 'devextreme-react/chart';
import { VisualRange } from 'devextreme-react/common/charts';
import CustomStore from 'devextreme/data/custom_store';
import { HubConnectionBuilder, HttpTransportType } from '@aspnet/signalr';
import TooltipTemplate from './TooltipTemplate.tsx';
const minVisualRangeLength = { minutes: 10 };
const defaultVisualRange: VisualRange = { length: 'hour' };
function App() {
const [dataSource, setDataSource] = useState(null);
const chartRef = useRef(null);
const customizePoint = useCallback((arg) => {
if (arg.seriesName === 'Volume') {
const point = chartRef.current.instance().getAllSeries()[0]
.getPointsByArg(arg.argument)[0].data;
if (point && point.close >= point.open) {
return { color: '#1db2f5' };
}
}
return null;
}, []);
const calculateCandle = useCallback<IAggregationProps['calculate']>((e) => {
const prices = e.data.map((d) => d.price);
if (prices.length) {
return {
date: new Date((e.intervalStart.valueOf() + e.intervalEnd.valueOf()) / 2),
open: prices[0],
high: Math.max.apply(null, prices),
low: Math.min.apply(null, prices),
close: prices[prices.length - 1],
};
}
return null;
}, []);
useEffect(() => {
const hubConnection = new HubConnectionBuilder()
.withUrl('https://js.devexpress.com/Demos/NetCore/stockTickDataHub', {
skipNegotiation: true,
transport: HttpTransportType.WebSockets,
})
.build();
const store = new CustomStore({
load: () => hubConnection.invoke('getAllData'),
key: 'date',
});
hubConnection
.start()
.then(() => {
hubConnection.on('updateStockPrice', (data) => {
store.push([{ type: 'insert', key: data.date, data }]);
});
setDataSource(store);
});
}, []);
return (
<div>
<Chart
id="chart"
ref={chartRef}
dataSource={dataSource}
title="Stock Price"
customizePoint={customizePoint}>
<Margin right={30} />
<Series
pane="Price"
argumentField="date"
type="candlestick">
<Aggregation
enabled={true}
method="custom"
calculate={calculateCandle} />
</Series>
<Series
pane="Volume"
name="Volume"
argumentField="date"
valueField="volume"
color="red"
type="bar">
<Aggregation
enabled={true}
method="sum" />
</Series>
<Pane name="Price"></Pane>
<Pane name="Volume" height={80}></Pane>
<Legend visible={false} />
<ArgumentAxis
argumentType="datetime"
minVisualRangeLength={minVisualRangeLength}
defaultVisualRange={defaultVisualRange} />
<ValueAxis placeholderSize={50} />
<ZoomAndPan argumentAxis="both" />
<ScrollBar visible={true} />
<LoadingIndicator enabled={true} />
<Tooltip
enabled={true}
shared={true}
argumentFormat="shortDateShortTime"
contentRender={TooltipTemplate}
/>
<Crosshair
enabled={true}>
<HorizontalLine visible={false} />
</Crosshair>
</Chart>
</div>
);
}
export default App;
import React, {
useCallback, useEffect, useRef, useState,
} from 'react';
import Chart, {
ArgumentAxis,
ValueAxis,
Aggregation,
Legend,
Series,
ScrollBar,
ZoomAndPan,
LoadingIndicator,
Pane,
Tooltip,
Crosshair,
Margin,
HorizontalLine,
} from 'devextreme-react/chart';
import CustomStore from 'devextreme/data/custom_store';
import { HubConnectionBuilder, HttpTransportType } from '@aspnet/signalr';
import TooltipTemplate from './TooltipTemplate.js';
const minVisualRangeLength = { minutes: 10 };
const defaultVisualRange = { length: 'hour' };
function App() {
const [dataSource, setDataSource] = useState(null);
const chartRef = useRef(null);
const customizePoint = useCallback((arg) => {
if (arg.seriesName === 'Volume') {
const point = chartRef.current
.instance()
.getAllSeries()[0]
.getPointsByArg(arg.argument)[0].data;
if (point && point.close >= point.open) {
return { color: '#1db2f5' };
}
}
return null;
}, []);
const calculateCandle = useCallback((e) => {
const prices = e.data.map((d) => d.price);
if (prices.length) {
return {
date: new Date((e.intervalStart.valueOf() + e.intervalEnd.valueOf()) / 2),
open: prices[0],
high: Math.max.apply(null, prices),
low: Math.min.apply(null, prices),
close: prices[prices.length - 1],
};
}
return null;
}, []);
useEffect(() => {
const hubConnection = new HubConnectionBuilder()
.withUrl('https://js.devexpress.com/Demos/NetCore/stockTickDataHub', {
skipNegotiation: true,
transport: HttpTransportType.WebSockets,
})
.build();
const store = new CustomStore({
load: () => hubConnection.invoke('getAllData'),
key: 'date',
});
hubConnection.start().then(() => {
hubConnection.on('updateStockPrice', (data) => {
store.push([{ type: 'insert', key: data.date, data }]);
});
setDataSource(store);
});
}, []);
return (
<div>
<Chart
id="chart"
ref={chartRef}
dataSource={dataSource}
title="Stock Price"
customizePoint={customizePoint}
>
<Margin right={30} />
<Series
pane="Price"
argumentField="date"
type="candlestick"
>
<Aggregation
enabled={true}
method="custom"
calculate={calculateCandle}
/>
</Series>
<Series
pane="Volume"
name="Volume"
argumentField="date"
valueField="volume"
color="red"
type="bar"
>
<Aggregation
enabled={true}
method="sum"
/>
</Series>
<Pane name="Price"></Pane>
<Pane
name="Volume"
height={80}
></Pane>
<Legend visible={false} />
<ArgumentAxis
argumentType="datetime"
minVisualRangeLength={minVisualRangeLength}
defaultVisualRange={defaultVisualRange}
/>
<ValueAxis placeholderSize={50} />
<ZoomAndPan argumentAxis="both" />
<ScrollBar visible={true} />
<LoadingIndicator enabled={true} />
<Tooltip
enabled={true}
shared={true}
argumentFormat="shortDateShortTime"
contentRender={TooltipTemplate}
/>
<Crosshair enabled={true}>
<HorizontalLine visible={false} />
</Crosshair>
</Chart>
</div>
);
}
export default App;
import React from 'react';
const formatCurrency = new Intl.NumberFormat('en-US',
{ style: 'currency', currency: 'USD', minimumFractionDigits: 0 }).format;
const formatNumber = new Intl.NumberFormat('en-US', {
minimumFractionDigits: 0,
}).format;
export default function TooltipTemplate(pointInfo) {
const volume = pointInfo.points.filter((point: { seriesName: string; }) => point.seriesName === 'Volume')[0];
const prices = pointInfo.points.filter((point: { seriesName: string; }) => point.seriesName !== 'Volume')[0];
return (
<div className="tooltip-template">
<div>{ pointInfo.argumentText }</div>
<div><span>Open: </span>
{ formatCurrency(prices.openValue) }
</div>
<div><span>High: </span>
{ formatCurrency(prices.highValue) }
</div>
<div><span>Low: </span>
{ formatCurrency(prices.lowValue) }
</div>
<div><span>Close: </span>
{ formatCurrency(prices.closeValue) }
</div>
<div><span>Volume: </span>
{ formatNumber(volume.value) }
</div>
</div>
);
}
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
jsx: 'react',
},
meta: {
'react': {
'esModule': true,
},
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
},
defaultExtension: 'js',
map: {
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'@aspnet/signalr': 'npm:@aspnet/signalr@1.0.27/dist/cjs',
'tslib': 'npm:tslib/tslib.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@24.2.7/cjs',
'devextreme-react': 'npm:devextreme-react@24.2.7/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.1/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.16/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.60/dist/dx-gantt.js',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.12',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'@aspnet/signalr': {
main: 'index.js',
defaultExtension: 'js',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.12/inferno/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
System.config(window.config);
import React from 'react';
const formatCurrency = new Intl.NumberFormat('en-US', {
style: 'currency',
currency: 'USD',
minimumFractionDigits: 0,
}).format;
const formatNumber = new Intl.NumberFormat('en-US', {
minimumFractionDigits: 0,
}).format;
export default function TooltipTemplate(pointInfo) {
const volume = pointInfo.points.filter((point) => point.seriesName === 'Volume')[0];
const prices = pointInfo.points.filter((point) => point.seriesName !== 'Volume')[0];
return (
<div className="tooltip-template">
<div>{pointInfo.argumentText}</div>
<div>
<span>Open: </span>
{formatCurrency(prices.openValue)}
</div>
<div>
<span>High: </span>
{formatCurrency(prices.highValue)}
</div>
<div>
<span>Low: </span>
{formatCurrency(prices.lowValue)}
</div>
<div>
<span>Close: </span>
{formatCurrency(prices.closeValue)}
</div>
<div>
<span>Volume: </span>
{formatNumber(volume.value)}
</div>
</div>
);
}
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/24.2.7/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
#chart {
height: 440px;
}
.tooltip-template span {
font-weight: 500;
}
using System.Collections.Generic;
using DevExtreme.MVC.Demos.Models.SignalRTickData;
using Microsoft.AspNet.SignalR;
namespace DevExtreme.MVC.Demos.Hubs {
public class StockTickDataHub : Hub {
private readonly TickDataService _service;
public StockTickDataHub() {
_service = TickDataService.Instance;
}
public IEnumerable<TickItem> GetAllData() {
return _service.GetAllData();
}
}
}
using DevExtreme.MVC.Demos.Hubs;
using Microsoft.AspNet.SignalR;
using Microsoft.AspNet.SignalR.Hubs;
using System;
using System.Collections.Generic;
using System.Threading;
using DevExpress.Data.Utils;
namespace DevExtreme.MVC.Demos.Models.SignalRTickData {
public class TickDataService {
public readonly static TickDataService Instance = new TickDataService(GlobalHost.ConnectionManager.GetHubContext<StockTickDataHub>().Clients);
private IHubConnectionContext<dynamic> Clients { get; set; }
private readonly object updateStockPricesLock = new object();
private TickItem[] tickData;
private int lastTickIndex;
private Timer timer;
private TickDataService(IHubConnectionContext<dynamic> clients) {
Clients = clients;
tickData = GenerateTestData();
lastTickIndex = tickData.Length - 1;
timer = new Timer(Update, null, 1000, 1000);
}
public IEnumerable<TickItem> GetAllData() {
var data = new List<TickItem>();
lock(updateStockPricesLock) {
for(var i = lastTickIndex; data.Count < 10000; i--) {
data.Add(tickData[i]);
if(i == 0) {
i = tickData.Length - 1;
}
}
}
return data;
}
private void Update(object state) {
lock(updateStockPricesLock) {
lastTickIndex = (lastTickIndex + 1) % tickData.Length;
var tick = tickData[lastTickIndex];
tick.Date = DateTime.Now;
BroadcastStockPrice(tick);
}
}
private void BroadcastStockPrice(TickItem item) {
Clients.All.updateStockPrice(item);
}
private TickItem[] GenerateTestData() {
var lastPrice = 140m;
var random = NonCryptographicRandom.System;
var slowRandomValue = random.NextDouble();
var data = new TickItem[60 * 60 * 20];
var curTime = DateTime.Now;
for(var i = 0; i < data.Length / 2; i++) {
lastPrice = Math.Round(lastPrice * (decimal)(1 + 0.002 * (-1 + 2 * random.NextDouble())), 2);
if(i % 50 == 0) {
slowRandomValue = random.NextDouble();
if(slowRandomValue > 0.3 && slowRandomValue <= 0.5) slowRandomValue -= 0.2;
if(slowRandomValue > 0.5 && slowRandomValue <= 0.7) slowRandomValue += 0.2;
}
var volume = (int)(100 + 1900 * random.NextDouble() * slowRandomValue);
data[data.Length - 1 - i] = new TickItem(lastPrice, volume, curTime.AddSeconds(-1 * i));
data[i] = new TickItem(lastPrice, volume, curTime.AddSeconds(-1 * (data.Length - 1 - i)));
}
return data;
}
}
}
To display updated data in real time, use the aggregation configuration object. In this object, set the enabled property to true, the method property to custom
, and then implement the calculate function to process the incoming data. In this demo, the calculate function aggregates data into a one point for each interval.
You can also use the contentTemplate function to update the tooltip content with incoming data.